# Nsleduje 2. st uebnice R
#Kdyby nefungoval import z MS Excel, tak v prosinci 2018 byla chyba 
# v aktualizaci package rlang, proto provete nsledujc:

install.packages("rlang")
library(rlang)

###### R posedm (Testy etnost)######

setwd("C:/Users/Navratil/Documents/R")
# setwd("C:/Users/uivatel/Documents/R") # cesta pro koln PC

####Ch-kvadrt test - jeden faktor####
# ch-kvadrt test se provd funkc chisq.test()

?chisq.test

# loha: Li se poet samc a samic pekroivch vodn tok pi obstarvn potravy? 
# Samc pekroilo vodn tok 7 a samic 13.
# H0: Nen rozdl v potu samc a samic, kter/ pekroily/i vodn tok;
# hladina vznamnosti alfa = 95% (= p mus bt men ne 0.05, abych mohl zamtnout H0)

pohlavi <- c(7, 13) #zadvm men hodnoty

chisq.test(pohlavi, p = c(0.5, 0.5)) #test oekvanho rovnomrnho rozdlen 

# atribut p stanov oekvan rozdlen a test testuje shodu dat s tmto rozdlenm

# Vsledek: X-squared = 1.8, df = 1, p-value = 0.1797
# H0 nemohu zamtnout, rozdl na hladin vznamnosti alfa=95% neexistuje (p je vt ne 0.05).


####Ch-kvadrt test - dva faktory####
# nejprve nahrajeme data

library(readxl)

data <- read_excel("C:/Users/Navratil/Documents/Navratil/ZF/Statistika/glm_glz_1.xlsx")
# data <- read_excel("E:/R/glm_glz_1.xlsx") # cesta k datm na Vaich flekch

# loha: Li se zastoupen potu pr podle spnosti podle toho v jakm porostu si 
# postavil hnzdo?
# H0: nen rozdl v etnostech hnzd v typu porostu mezi typy spnosti pr;
# hladina vznamnosti alfa = 95% (= p mus bt men ne 0.05, abych mohl zamtnout H0)

# Nejprve musm vytvoit kontingenn tabulku, kter se tvo pkazem table() a atributy 
# udvaj z jakch faktor se m tabulka vytvoit.

ctab <- table(data$typ, data$porost)
ctab

# no a nsledn ji budme testovat

chisq.test(ctab)

# vsledek: X-squared = 23.813, df = 6, p-value = 0.0005652
#   Warning message:
#   In chisq.test(ctab) : Chi-squared approximation may be incorrect
# Vsledek testu je tedy vysoce prkazn, ale jsou porueny pedpoklady pouit testu - 
# vce ne 20% hodnot je mench ne 5, musme sluovat podobn porosty (podobn jsou 
# 1 s 2 a 3 s 4), ili nov kategorie 1 bude sluovat etnosti porostu 1 a 2 a 
# nov kategorie 2 bude sluovat etnosti v podobnch porostech 3 a 4

ctab2 <- cbind(ctab[,"1"] + ctab[,"2"], ctab[,"3"] + ctab[,"4"])
ctab2

# provedeme test na upravench datech

chisq.test(ctab2)

# vsledek: X-squared = 11.11, df = 2, p-value = 0.003868
# H0 zamtm, rozdl na hladin vznamnosti alfa=95% existuje (p je men ne 0.05).



####Fisherv exaktn test####

# Zadn lohy je identick jako v pedchozm ppad, testujeme tabulku ctab
# H0: nen rozdl v etnostech hnzd v typu porostu mezi typy spnosti pr;
# hladina vznamnosti alfa = 95% (= p mus bt men ne 0.05, abych mohl zamtnout H0)

# Fisherv exaktn test pro vliv dvou faktor se provn funkc fisher.test()
?fisher.test

fisher.test(ctab)

# vsledek: p-value = 0.0005793 ; alternative hypothesis: two.sided
# H0 zamtm, rozdl na hladin vznamnosti alfa=95% existuje (p je men ne 0.05).



####Kolmogorov-Smirnov test####

# Li se poet lokalit podle vegetanch jednotek od rovnomrho zastoupen jednotek
# v krajin? Zazanmnali jsme v prvnm typu 3 loklaity, ve druhm 7 lokalit a ve tetm 11 lokalit.

# H0: poetnost lokalit v typech vegetace je rovnomrn;
# hladina vznamnosti alfa = 95% (= p mus bt men ne 0.05, abych mohl zamtnout H0)

# data:
obs <- c(3,7,11)
exp <- c(7,7,7)

# test pomoc pkazu ks.test()
?ks.test

ks.test(obs,exp)

# vsledek: D = 0.33333, p-value = 0.9963 ; alternative hypothesis: two-sided
# warning message mete v tomto ppad ignorovat
# H0 nemohu zamtnout, rozdl na hladin vznamnosti alfa=95% neexistuje (p je vt ne 0.05).


####Vizualizace etnost####


###Kolov graf###
# Klasick kolov grafy se tvo pkazem pie()
?pie

# Vytvome kolov graf pro zystoupen typ vegetace z pkladu K-S testu

pie(obs, labels=c("vegetace 1", "vegetace 2", "vegetace 3"), main = "Zastoupen vegetanch typ", init.angle=90, col=gray(seq(from=0, to=1, length=3)), clockwise = T)

# Atributy - labesl tvo popisky, main vlo nzev, init.angle ud poten 
# hel pro zobrazovn, col zadv barvu, clockwise True zajist poad podle 
# hodinovch ruiek.

# Ovldn barev:
pie(obs, col=c("yellow", "blue", "red")) # vybran barvy
pie(obs, col=rainbow(3,start=0.1,end=0.5)) # barvy duhy s nastavenm potku a konce vbru barev
pie(obs, col=terrain.colors(3)) # paleta "tern"

# Legenda: 
# je j teba pidat pkazem legend()
legend("topright", legend=c("vegetace 1", "vegetace 2", "vegetace 3"), fill=terrain.colors(3))

# prvn atribut je umstn, pak je, co m obsahovat a nsledn se definuj barvy, monost prav
# je velmi mnoho 
?legend

###Mozaikov graf###
# mozaikov graf se tro pkazem mosaicplot()

?mosaicplot

# Vytvome mozaikov graf pro podly typ pr v typech vegetace z pkladu o hnzdech vodnch ptk

mosaicplot(ctab, shade = T, cex = .9, main = "Typy hnzd ve vegetaci")

# Atributy - shade True zajist vybarven hlavnch diferenc, cex je atribut ovldajc relativn 
# velikost psma v grafu.
# Vynikajc je, e pkaz mosaicplot() lze pout i na pole (Array), tedy vcerozmrnou matici.



###### R poosm (testy pro ordinln data o dvou vbrech)######

# Testy pro ordinln data, kter poznme dle, pracuj na principu porovnvn poad 
# namench hodnot, vyplv to z podstaty ordinlnch dat - vme, co je vt a 
# co men, ale nevme o kolik, v poad u vme o kolik poad se sla li.

setwd("C:/Users/Navratil/Documents/R")
# setwd("C:/Users/uivatel/Documents/R") # cesta pro koln PC

library(readxl)

data <- read_excel("C:/Users/Navratil/Documents/Navratil/ZF/Statistika/data1.xlsx")
# data <- read_excel("E:/R/data1.xlsx") # cesta k datm na Vaich flekch

####Mann-Whitney test####

# M-W test je uren k testovn rozdl v poad namench hodnot pro dva nezvisl vbry,
# je tedy obdobou dvouvbrovho t-testu. Meme ho pout i na pomrov data, pokud 
# nespluj podmnku pouit t-testu (nejastji tedy v ppadech, kdy data sice jsou 
# pomrov, ale nemaj normln rozdlen).

# M-W test se v R pot pomoc funkce wilcox.test():

?wilcox.test

# Zadejme si stejn kol jako u dvouvbrovho t-testu:
# Testuji rozdl v pH1 mezi vbry identifikovanmi ve sloupci bohatost, tedy se ptm, jestli
# se li hodnota pH meen na jae (pH1) mezi lokalitami druhov bohatmi a chudmi
# H0: pH men na jae se neli mezi lokalitami druhov bohatmi a chudmi
# hladina vznamnosti alfa = 95% (= p mus bt men ne 0.05, abych mohl zamtnout H0)

# nejprve se podvejme na grafiku toho, co testuji

boxplot(data$pH1~data$bohatost, names=c("bohat", "chud"), main="pH1 na raelinitch", xlab="vbry", ylab="pH")

# a te vlastn M-W test: 

wilcox.test(data$pH1~data$bohatost)

# vsledek: W=99, p=0.002183
# H0 zamtm, rozdl na hladin vznamnosti alfa=95% existuje (p je men ne 0.05).
# varovn nemuste vnovat pozornost

# Jen pro zopakovn rozhodovn o H0 s ohledem na stanoven alfa:
# Vimte si, e na hladin vznamnosti alfa=99.9% bych H0 zamtnout nemohl,
# nebo p=0.0022, je tedy vt ne 99.9% (0.001).

# Jako u t-testu je zde atribut alternative = "two.sided" pro oboustrann test (automaticky 
# nastaveno) a alternative = "greater" nebo "less" pro jednostrann testy 

# POZNMKA: M-W test lze v R potat i v ppad, e kad vbr je vektor nebo
# je ve "svm" sloupci datov tabulky:

vyber1 <- c(23, 25, 31, 22, 28, 26) # zadvm prvn vbr
vyber2 <- c(22, 21, 28, 27, 23, 16) # zadvm druh vbr
tab1 <- cbind(vyber1, vyber2) # vytvom matici
tab1 <- as.data.frame(tab1) # vytvom z matice tabulku dat

wilcox.test(vyber1, vyber2) # vpoet z vektor
wilcox.test(tab1$vyber1, tab1$vyber2) # vpoet ze sloupc datov tabulky

# vsledek: W=25,5, p=0.2598
# H0 nezamtm, rozdl na hladin vznamnosti alfa=95% neexistuje (p je vt ne 0.05).


####Wilcoxonv test####

# Wilcoxonv test je obdobou provho t-testu, slou tedy k testovn rozdlu ve dvou 
# zvislch vbrech. Atribut, kter udl z dvouvbrovho testu test prov je stejn 
# jako u t-testu, paired = TRUE.
# Pkaz je stejn jako M-W testu, tedy wilcox.test()

# kol bude opt stejn jako u provho t-testu:
# Li se prvn a druh men pH?
# H0: nen rozdl mezi pH menm na jae (pH1) a v asnm lt (pH2)
# hladina vznamnosti alfa = 95% (= p mus bt men ne 0.05, abych mohl zamtnout H0)

wilcox.test(data$pH1, data$pH2, paired = TRUE)

# vsledek: V=13, p = 0,0006356
# H0 na hladin vznamnosti alfa=95% zamtm a tedy men na jae a v asnm lt se li
# co je vt a co men zjistme nap. v boxplotu

boxplot(data$pH1, data$pH2, names=c("pH1", "pH2"), main="pH na raelinitch", xlab="men", ylab="pH")


####Jednovbrov testy####

# K testovn shody s teoretickm rozdlenm se pro ordinln data nejastji pouv 
# ch-kvadrt test nebo Kolmogorov-Smirnov test.



###### R podevt (vce vbr, jeden faktor)######

# POZOR:
# V zkladnm kurzu testujeme pouze vliv jednoho faktoru. 
# ANOVA je v prv ad urena pro vyhdnocovn experiment - pedpokld
# stejn poet men v jednotlivch kombinacch rovn faktor (k se 
# tomu Typ I, model je vyven "wieghted"). Nsledujc vpoty jsou na 
# datech se stejnm potem men, pokud je nemte, tak, aby byly Vae
# vsledky odpovdajc, je teba mt velk poty men v jednotlivch 
# skupinch.

setwd("C:/Users/Navratil/Documents/R")
# setwd("C:/Users/uivatel/Documents/R") # cesta pro koln PC

library(readxl)

data <- read_excel("C:/Users/Navratil/Documents/Navratil/ZF/Statistika/vice_vyberu.xlsx")
# data <- read_excel("E:/R/vice_vyberu.xlsx") # cesta k datm na Vaich flekch

data2 <- as.data.frame(data) # pro nkter pkazy je NUTN mt data.frame!!!!!

data2$poloha <- as.factor(data2$poloha) # pro nkter pkazy je NUTN mt 
# kategoriln prediktory zadan jako faktory!!!!!


####One-way ANOVA####

# Podmnky pouit:
# - nezvisl vbry (= rovn faktoru)
# - data na pomrov stupnici
# - normln rozdlen dat
# - homogenita varianc 

# Vpoet se naume na testovn zvislosti vky rostliny na me oslunn, 
# kter m 3 rovn:

boxplot(vka~poloha, data=data2) # v krabicovm grafu se podvejme na data

# Splnn podmnek?
# - nezvisl vbry mme
# - data jsou na pomrov stupnici
# - je teba otestovat normalitu (dlat cvin nebudeme - nauili jsme se dve)
# - musme otestovat homogenitu varianc



###Levenev test###

# Levenev test je uren k testovn homogenity varianc - tento test v zkladu 
# R nen, je teba naistalovat package - nejobshlej pro een loh ANOVA 
# je package "car"

install.packages("car") # bude to njakou dobu trvat (nkdy dost dlouho)

library(car) # chybovm hlkm nemuste prozatm vnovat pozornost

?leveneTest 

# Zadn je stejn jako u provho t-testu (variant je tady ale vce) 
# a zadv se atribut "center" s hodnotou "mean", poppad "median", 
# pak atribut "data" s hodnotou nzvu tabulky (data.frame)
# kol: Otestujte homogenitu varianc vky rostliny v kategorich polohy rostliny
# H0: varince mezi vbry se neli
# hladina vznamnosti alfa = 95% (= p mus bt men ne 0.05, abych mohl zamtnout H0)

leveneTest(vka~poloha, data=data2, center=mean)

# nebo

leveneTest(data2$vka, data2$poloha, center=mean)

# Vsledek:
#        Df F value Pr(>F)
# group  2  0.766 0.473
#        33   
# H0 nezamtm, rozdl na hladin vznamnosti alfa=95% neexistuje (p je vt ne 0.05)

# Robustnj variantou (= mn nchylnou k poruen pedpoklad testu) 
# je medinov Brown-Forsythe test homogenity varianc - center=median

leveneTest(data2$vka, data2$poloha, center=median)

# Vsledek:
#        Df F value Pr(>F)
# group  2  0.7447 0.4827
#        33   
# H0 nezamtm, rozdl na hladin vznamnosti alfa=95% neexistuje (p je vt ne 0.05)


###Vlastn ANOVA###

# Nejjednodu variantou je pouit vestavn funkce v R pro ANOVA aov()
# POZOR - jejm pedpokladem je pouit pro stejn poty men ve vbrech
# (tzv. Typ I), pokud mte rzn poty, tak muste pout jinou funkci.

?aov

# loha: Otestujte, jestli se li vka rostliny podle toho, zda rostla 
# na slunci, v polostnu nebo ve stnu.
# H0: Prmrn vka rostliny se ve tech vbrech neli
# hladina vznamnosti alfa = 95% (= p mus bt men ne 0.05, abych mohl zamtnout H0)

aov(vka~poloha, data=data2)

# vsledek:
# Sum of Squares  10951.38  42608.41
# Deg. of Freedom        2        33
# Residual standard error: 37.70643
# Estimated effects may be unbalanced

# Mme k dispozici SS a d.f., to toho moc nen, take bude teba si zobrazit
# to, co ns zajm, stejn jako nap. u histogramu si budeme muset
# vsledek nejprve uloit:

anova_vysledek <- aov(vka~poloha, data=data2)

summary(anova_vysledek) # summary() je pkaz k vypsn specifick sti vsledk

# Vsledek:
#            Df Sum Sq Mean Sq F value Pr(>F)
# poloha       2  10951    5476   4.241  0.023 *
# Residuals   33  42608    1291                 
# ---
# Signif. codes:  0 *** 0.001 ** 0.01 * 0.05 . 0.1   1
# H0 zamtm, rozdl na hladin vznamnosti alfa=95% existuje (p je men ne 0.05)
# Chcete-li se dostat k dalm vsledkm sta zadat patin atribut za $, nap.

anova_vysledek$coefficients # vype koeficienty linernho modelu

# Skvl, otestovali jsme, e se prmry li, ovem u nevme jak.
# K identifikaci odlinch prmr slou dal testy, kter se
# oznauj jako post-hoc testy a jejich clem je identifikovat rozdly
# ve vsledcch ANOVA.



###Tukeyho post-hoc test###

# Zkladnm testem pro porovnn prmr je Tukey HSD post-hoc test:

?TukeyHSD

# kol: pokraujeme v pedchozm pklad
# H0slunce-polostn: prmry na slunci a v polostnu se neli
# H0stn-polostn: prmry ve stnu a v polostnu se neli
# H0stn-slunce: prmry ve stnu a na slunci se neli
# vude hladina vznamnosti alfa = 95% (= p mus bt men ne 0.05, abych mohl zamtnout H0)

TukeyHSD(anova_vysledek) # aplikujeme na vsledek ANOVA

# Vsledek:
#                    diff       lwr      upr     p adj
# slunce-polostn -11.15000 -47.14592 24.84592 0.7297260
# stn-polostn    30.14167  -5.85425 66.13758 0.1151664
# stn-slunce      41.29167   5.29575 77.28758 0.0216883
# H0slunce-polostn: nezamtm
# H0stn-polostn: nezamtm
# H0stn-slunce: zamtm

# Pokud chcete graf prmrnch rozdl s 95%  intervaly spolehlivosti,
# tak pouijte pkaz "plot":

plot(TukeyHSD(anova_vysledek)) # jde tedy o graf vsledku TukeyHSD na data
# anova_vysledek, co je datov struktura typu list (seznam)

# Mno a pokud chcete graf s prmry +/- SE a zobrazeny vechny body, tak pouijete 
# funkci ggline v package ggpurbr:

install.packages("ggpubr")

library(ggpubr)

ggline(data, x = "poloha", y = "vka", 
       add = c("mean_se", "jitter"), 
       order = c("slunce", "polostn", "stn"),
       ylab = "vka v cm", xlab = "poloha")

# v add je "mean_se" prmr +/- SE a "jitter" jsou body



###Dunnettv test pro porovnn s kontroln skupinou###

# Pokud mte experimet, tak mte jist kontroln skupinu a clem Vaeho 
# post-hoc testovn nebude porovnn veho se vm, ale porovnn
# vech zsah s kontroln skupinou - k tomu slou Dunnettv test, 
# ten v zkladu R nen a je teba instalovat package - multcomp:

install.packages("multcomp")

library(multcomp)

# Pkaz pro post-hoc testovn je glht(), prvnm atributem je model - v naem
# ppad to je list anova_vysledek, co je vsledek z funkce aov()

?glht

summary(glht(anova_vysledek, linfct=mcp(poloha = "Dunnett")))

# POZOR:
# Jako kontrolu bere pkaz skupinu prvn v abeced (na to je teba myslet pi 
# kdovn) n pklad nen praktick, jen ilustrativn(!!!!!), take se jako 
# kontrola bere "polostn"
# Vsledek:
# Simultaneous Tests for General Linear Hypotheses
# Multiple Comparisons of Means: Dunnett Contrasts
# Fit: aov(formula = vka ~ poloha, data = data)
# Linear Hypotheses:
#                          Estimate Std. Error t value Pr(>|t|)  
# slunce - polostn == 0   -11.15      14.67  -0.760   0.6686  
# stn - polostn == 0      30.14      14.67   2.055   0.0863 .
# ---
#  Signif. codes:  0 *** 0.001 ** 0.01 * 0.05 . 0.1   1
# (Adjusted p values reported -- single-step method)
# ob H0 nemohu zamtnout


###TukeyHSD podruh###

# V package "multcomp" je povcero pkaz a je mezi nimi i pkaz cld
# Vypotejme Tukey HSD test pomoc pkazu glht a ulome jej jako objekt:

tuk1 <- (glht(anova_vysledek, linfct=mcp(poloha = "Tukey")))

# ulome vsledek pkazu cld jako objekt tuk2:

tuk2 <- cld(tuk1)

# vytvome graf z objektu tuk2

plot(tuk2)

# Psmeny jsou zobrazeny tzv. homogenn skupiny, tedy skupiny rovn faktoru,
# kter se na dan hladin vznamnosti neli.



####RMANOVA####

# RMANOVA ja urena pro vbry, kter nejsou nezvisl - nejastji, kdy 
# provedete vce men na jednotlivch objektech.

# kol: Li se meen pH na jae, v asnm lt, pozdnm lt a na podzim?
# H0: men pH se neli
# hladina vznamnosti alfa = 95% (= p mus bt men ne 0.05, abych mohl zamtnout H0)

# Data:
datarm <- read_excel("C:/Users/Navratil/Documents/Navratil/ZF/Statistika/rmanova.xlsx")
# datarm <- read_excel("E:/R/rmanova.xlsx") # cesta k datm na Vaich flekch

# Nejprve stanovme formty

datarm <- as.data.frame(datarm)
datarm$nr <- as.factor(datarm$nr)
datarm$mereni <- as.factor(datarm$mereni)

# daje jsou pod sebou ve sloupci "hodnota", sloupec "mereni" identifijuje 
# poad men (je to 4-rovov faktor, kde jednotliv rovn nejsou 
# nezvisl), a sloupec "nr" identifikuje objekt - POZOR je nutn mt 
# tento identifiktor a mus to bt faktor!!!!!!!

rmanova <- aov(hodnota ~ mereni + Error(nr/mereni), data=datarm)
summary(rmanova)

# pouili jsme opt pkazu aov(), tedy Typ I
# Vsledek:
#Error: nr
#           Df Sum Sq Mean Sq F value Pr(>F)
# Residuals 20  17.36  0.8679               
# Error: nr:men
#            Df Sum Sq Mean Sq F value  Pr(>F)    
# men     3  14.66   4.886   10.27 1.5e-05 ***
# Residuals 60  28.54   0.476                    
#---
#  Signif. codes:  0 *** 0.001 ** 0.01 * 0.05 . 0.1   1
# H0 zamtm nebo p je vrazn men ne 0.05

# POZNMKA: RMANOVA testuje tzv. "within" efekt a zadn je v podstat 
# odpovdajc zadn dvoufaktorov ANOVA, kde interakce nr/mereni je 
# nhodn efekt - vce viz navazujc kurz.

# Problmem je post-hoc - k vsledku aov() si jej muste vypotat v 
# R run. Pokud jej chcete vypotat pkazem, muste pout jin 
# pkaz - my jej pouijeme, ale nebudeme si jej na tomto mst 
# vysvtlovat - opt viz navazujc kurz.

# Budeme potebovat knihovnu "lme4", kter by se mla naistalovat 
# souasn s "car".

library(lme4)

# K vpotu je poteba pout smenho linernho modelu, tentokrt 
# ale nikoliv Typ I, ale Typ III, proto je report vsledku podobn vsledkm 
# z regrese (viz 11. kapitola). Pouije se pkaz lmer pro tvorbu modelu 
# (na msto aov) z pagkage "lme4":

rmanova2 <- lmer(hodnota ~ mereni +(1|nr), data=datarm) 

# (1|nr) je nhodn efekt men na danm objektu, potan podle Typu III

summary(rmanova2) # vsledek modelu

anova(rmanova2) # anova() je pkaz package "car" a dv vsledek ANOVA modelu

# Vsledek je stejn jako v ppad pouit pkazu aov():
# Analysis of Variance Table
#        Df Sum Sq Mean Sq F value
# mereni  3 14.657  4.8858   10.27

# POZOR!!!!!! - stejn nebude, kdy bychom mli "unballanced" data!!!!!!!


###Pos-hoc pro RMANOVA###

# Pro post-hoc testovn pouijeme opt package "multcomp" a pkazu "glht"

# kol: Hledme dvojice v mench pH, ve kterch jsou rozdly
# H0: je jich tolik, kolik je kombinac rovn a H0 zn tak, e dl 
# kombinace se neli
# alfa = 95%, (p mus bt men ne 0,0,5, abychom mohli zamtnout H0)

summary(glht(rmanova2, linfct=mcp(mereni = "Tukey")), test = adjusted(type = "bonferroni"))

# pouili jsme Bonferroniho korekci - jde o RMANOVA a testujeme "within" efekt

# Vsledek:
# Simultaneous Tests for General Linear Hypotheses
# Multiple Comparisons of Means: Tukey Contrasts
# Fit: lmer(formula = hodnota ~ men + (1 | nr), data = datarm)
#Linear Hypotheses:
#                Estimate Std. Error z value Pr(>|z|)    
# pH2 - pH1 == 0   0.5948     0.2129   2.794  0.03122 *  
# pH3 - pH1 == 0   1.1581     0.2129   5.441 3.18e-07 ***
# pH4 - pH1 == 0   0.7748     0.2129   3.640  0.00164 ** 
# pH3 - pH2 == 0   0.5633     0.2129   2.647  0.04879 *  
# pH4 - pH2 == 0   0.1800     0.2129   0.846  1.00000    
# pH4 - pH3 == 0  -0.3833     0.2129  -1.801  0.43030    
# ---
#  Signif. codes:  0 *** 0.001 ** 0.01 * 0.05 . 0.1   1
# (Adjusted p values reported -- bonferroni method)

# Tam, kde jsou hvzdiky, mohu H0 zamtnout




####Kruskal-Wallis test a jeho mnohonsobn porovnn####

# Kruskal-Wallis test je "ANOVA" definovna na ordinlnch datech 
# - hodnot poad a je rozenm Mann-Whitney testu. K-W test je 
# v zkladu R a pkaz je kruskal.test().Test je uren pro posouzen 
# "between" efektu.
# POZOR: data grupovac promnn mus bt seazena abecedn pkazem ordered()

data2$poloha <- ordered(data2$poloha, levels = c("polostn", "slunce", "stn"))

?kruskal.test

# kol: Otestejtuje, jestli se li vka rostliny podle toho, jestli 
# rostla na slunci, v polostnu nebo ve stnu.
# H0: prmrn vka rostliny se ve tech vbrech neli.
# hladina vznamnosti alfa = 95% (= p mus bt men ne 0.05, abych mohl zamtnout H0)

kruskal.test(vka~poloha, data=data2)

# Vsledek:
# Kruskal-Wallis rank sum test
# data:  vka by poloha
# Kruskal-Wallis chi-squared = 8.0826, df = 2, p-value = 0.01757
# H0 zamtm, rozdl na hladin vznamnosti alfa=95% existuje (p je men ne 0.05)

# Pro mnohonsobn porovnn se poije M-W tests s upravenou hodnotou p

pairwise.wilcox.test(data2$vka, data2$poloha, p.adjust.method = "BH")

# Vsledek: 
# 	Pairwise comparisons using Wilcoxon rank sum test 
# data:  data$vka and data$poloha 
#        polostn slunce
# slunce 0.478    -     
# stn   0.103    0.011 
# P value adjustment method: BH 
# Vsledkem je tedy matice v n jsou uvedeny hodnoty p
# V naem ppad rozdly prokzny tmto testem nebyly s vjimkou stn-slunce
# (jen zde H0 na p men ne 0,05 zamtm)

# Dle lze pout pkaz posthoc.kruskal.nemenyi.test(), kter je
# v package PMCMR

install.packages("PMCMR")

library(PMCMR)

posthoc.kruskal.nemenyi.test(data2$vka, data2$poloha)

# Vsledek:
# Pairwise comparisons using Tukey and Kramer (Nemenyi) test	
# with Tukey-Dist approximation for independent samples
# data: data$vka and data$poloha
#        polostn slunce
# slunce 0.682    -     
# stn   0.128    0.015 
# v naem ppad rozdly prokzny tmto testem nebyly s vjimkou stn-slunce 
# (jen zde H0 na p men ne 0,05 zamtm)



#### Friedmanv test a jeho mnohonsobn porovnn####

# Friedmanv test je analogi Wilcoxonova testu pro vce ne 2 vbry a tedy 
# neparametrickou variantou RMANOVA. Pkaz je v zkladu R a zn friedman.test()

?friedman.test

# Pro pkaz jsou hlavn prvn ti parametry: na prvnm mst muste uvst 
# zvislou promnnou, na druhm mst skupinu pri nich chcete testovat "within"
# efekt a nakonec blok, ve kterm bylo men provedeno (= nap. lokalita, 
# kde bylo provedeno opakovn).

# kol: stejn jako u RMANOVA

friedman.test(datarm$hodnota, datarm$mereni, datarm$nr)

# Vsledek:
# Friedman rank sum test
# data:  datarm$hodnota, datarm$mereni and datarm$nr
# Friedman chi-squared = 33.431, df = 3, p-value = 2.613e-07

# K mnohonsobnmu porovnn pouijeme opt package PMCMRplus, tentokrt 
# s pkazem posthoc.friedman.nemenyi.test()

posthoc.friedman.nemenyi.test(datarm$hodnota, datarm$mereni, datarm$nr)

# Vsledky:
# Pairwise comparisons using Nemenyi multiple comparison test	
# with q approximation for unreplicated blocked data
# data: datarm$hodnota , datarm$mereni and datarm$nr
#      pH1     pH2    pH3   
# pH2 0.0789  -      -     
# pH3 8.2e-08 0.0056 -     
# pH4 0.1986  0.9754 0.0012
# P value adjustment method: none
# H0 zamtm, kde je hodnota men ne 0,05



###### R podest (kovariance a korelace)######

setwd("C:/Users/Navratil/Documents/R")
# setwd("C:/Users/uivatel/Documents/R") # cesta pro koln PC

library(readxl)

data <- read_excel("C:/Users/Navratil/Documents/Navratil/ZF/Statistika/data1.xlsx")
# data <- read_excel("E:/R/data1.xlsx") # cesta k datm na Vaich flekch
data <- as.data.frame(data) # vytvome ze vstupnch dat datovou tabulku


####Kovariance####

# R m pro kovariance vestavnou funkci cov() a lze s n vypotat pedevm hodnotu 
# kovariance dvou promnnch:

cov(data$Ca1, data$Mg1) # kovariance Ca1 a Mg1

# Lze ale tak vypotat kovarian matici, nejprve si ale vyberme z dat pomrov
# promnn a vytvome novou datovou tabulku:

data2 <- data.frame(data$NH4N1, data$NO3N1, data$TP1, data$Mg1, data$Ca1, data$c1, data$pH1)

cov(data2) # vypot kovarian matici

# Pokud nkoho pekvapilo, e na diagonle nejsou jedniky nebo nuly, tak jen 
# pipomnme, e na diagonle jsou rozptyly dan promnn - viz vzorec kovariance.



####Korelace####

# Korelace m vestavn pkaz cor() a jeho pouit je identick 
# s kovarianc, jen mme monost volit typ korelace v parametru method a 
# na vbr mme pearson, spearman a kendall

cormat1 <- cor(data2, method="pearson") # pro Pearsonv k.k.
cormat2 <- cor(data2, method="spearman") # pro Poadov Spearmanv k.k.
cormat3 <- cor(data2, method="kendall") # pro Kendall Tau k.k.

# V zkladu bohuel nelze koeficienty testovat, nicmn lze pout package
# corrplot

install.packages("corrplot")

library(corrplot)

# Pkaz na vpoet matice statistick vznamnosti korelanch koeficient
# je cor.mtest()

cor.mtest(data2)

p.data2 <- cor.mtest(data2) # vsledk si ulome, pa ho za chvli budeme potebovat

# Vizualizace souvislosti je mon mnoha zpsoby nejjednodu je xy graf

plot(data2$data.Ca1, data2$data.Mg1)

# irok spektrum monost vizualizace korelan matice pak nabz 
# ve nainstalovan package corrplot

# Pkaz je corrplot() a m velk mnostv atrubut a parametr

corrplot(cormat1, method = "circle")

# Tohle je nejjednodu monost - barva a velikost koleet ukazuj velikost 
# k.k., lze do nj ale i vloit vsledek testu statistick vznamnosti:

corrplot(cormat1, method = "circle", p.mat = p.data2$p, sig.level = .05)

# nebo si lze prohrt:

corrplot(cormat1, method = "shade", type = "upper" , p.mat = p.data2$p, 
         sig.level = c(.001, .01, .05), pch.cex = .9,
         insig = "label_sig", pch.col = "white")

# kompletn pehled je tady: https://cran.r-project.org/web/packages/corrplot/vignettes/corrplot-intro.html



####Parciln korelace####

# Parciln korelan koeficienty lze zskat pkazem pcor 
# z package ppcor:

install.packages("ppcor")

library(ppcor)

pcor(data2, method = "pearson")

# Vsledkem pkazu jsou matice parcilnch k.k. (odeten je vdy vliv 
# vech ostatnch promnnch - $estimate) a matice statistick vznamnosti
# k.k. ($p.value)



####Mnohonsobn korelace####

#  V R nen dn pm nstroj pro vpoet mnohonsobnho korelanho 
# koeficientu. Bu si jej vypotte run z korelan matice - funkce pro
# vpoet koeficientu determinance matice je det(), nebo se d R zjistit 
# z regres, na kter se podvme pt.



###### R pojedenct (linern regrese)######

setwd("C:/Users/Navratil/Documents/R")
# setwd("C:/Users/uivatel/Documents/R") # cesta pro koln PC

library(readxl)

ostrorep <- read_excel("C:/Users/Navratil/Documents/Navratil/ZF/Statistika/korelace.xlsx")
# ostrorep <- read_excel("E:/R/korelace.xlsx") # cesta k datm na Vaich flekch
ostrorep <- as.data.frame(ostrorep) # vytvome ze vstupnch dat datovou tabulku


####Jednoduch linern regrese####

# Linern regrese m v R vestavnou funkci lm()

# kol: Existuje zvislost mnostv samc ostrorepa zavench pi pen
# na ce krune samice?

plot(ostrorep$samice.sirka, ostrorep$samci.biomasa) # grafick vyjden

cor(ostrorep$samice.sirka, ostrorep$samci.biomasa) # Pearsonv k.k.=0,339

# Vazba mezi promnnmi je, zkusme ji kvantifikovat regres:

samci1 <- lm(ostrorep$samci.biomasa~ostrorep$samice.sirka) # ulome vsledek

summary(samci1)

# Vsledek - test modelu (je na poslednm dku):
# F-statistic: 22.34 on 1 and 171 DF,  p-value: 4.76e-06
# model je statisticky prkazn

# Vsledek - mra vysvtlen variability (je na pedposlednm dku):
# Multiple R-squared:  0.1155,	Adjusted R-squared:  0.1104 
# ka samice vysvtluje 11,04% variability dat o biomase zavench samc -
# - je to hodnota Adjusted R-squared

# Vsledek - regresn rovnice - zjist se z tohoto:
# Coefficients:
#                    Estimate Std. Error t value Pr(>|t|)    
# (Intercept)        -25.435      6.911  -3.680 0.000312 ***
# data$samice.sirka    1.238      0.262   4.726 4.76e-06 ***
# rovnice je: biomasa samc = -25,435 + 1.238*ka samice
# koeficient ky samice se vysoce prkazn li od nuly (= posledn sloupec)

# Grafick vyjden linern regrese:

plot(ostrorep$samice.sirka, ostrorep$samci.biomasa)
abline(samci1, col=2, lwd=3) # vlo regresn pmku do pedchozho grafu



###Regresn diagnostika###

# Posuzujeme normalitu rezidul a jeich zvislost na velikosti men hodnoty
# Grafy regresn diagnostiky se volaj funkc plot(), kter zde ale m jin 
# charakter zobrazen vsledk - graf je povcero a zobrazuj se po zmknut
# klvesy "Enter" - Hit <Return> to see next plot v Console

plot(samci1)

# 1: Residuals vc. Fitted zobraz reziduly oproti dan hodnot na regresn pmce
#    linie by mla bt rovn a body tvoit oblak bez odlehlch hodnot - tady ti mme;
#    rozptyl rezidul nem rst s rostouc hodnotou Fitted; pokud navc data nejsou
#    v linern zvislosti, tak linie v tomto grafu tvo kivku
# 2: Normal Q-Q - ten znme, body by mly bt kolem pmky (zde se jedn o posouzen 
#   normality rezidul)
# 3: Scale-Location - zvislost rezidul na hodnot Fitted - nesm kontinuln rst;
#    pokud navc data nejsou v linern zvislosti, tak linie v tomto grafu tvo kivku
# 4: Residuals vs. Leverage - nebudeme pouvat

# Diagnostikou byla potvrzena vhodnost modelu, ale identifikovna byla ti odlehl
# men - mli bychom se podvat, o jak men jde a, pokud si to okolnostmi
# meme dovolit, tato men odstarnit a pepotat model znovu.


####Mnohonsobn linern regrese####

# Prci si vysvtlme na pkladu dat z raelini a budeme se snait vysvtlit druhovou 
# bohatost na lokalitch (promnn = richness)

rich <- read_excel("C:/Users/Navratil/Documents/Navratil/ZF/Statistika/data1.xlsx")
# rich <- read_excel("E:/R/data1.xlsx") # cesta k datm na Vaich flekch
rich <- as.data.frame(rich) # vytvome ze vstupnch dat datovou tabulku

# Testujme zvislos potu druh na pH, mnostv minerl, mnostv dusku a mnostv fosforu

reg.rich <- lm(rich$richness~rich$pH1+rich$c1+rich$NH4N1+rich$TP1)

summary(reg.rich)

# Vsledek: Test H0, e vechny koeficienty jsou 0 meme zamtnout:
# F-statistic: 3.322 on 4 and 16 DF,  p-value: 0.03674
# Vsledek: Statisticky vznamn vliv na druhovou bohatost m pouze pH
#                 Estimate Std. Error t value Pr(>|t|)  
# rich$pH1     9.953e+00  3.769e+00   2.641   0.0178 *

plot(reg.rich) # v grafu Scale-Location je identifikovna heteroskedasticita




####Vbr promnnch pro model####

# Clem mnohonsobn linern regrese je vytvoit model, kter je statisticky prkazn
# a zrove nejjednosu. Proto bysme se mli snait takov model vytvoit.

# V naem ppad vypadaj koeficienty takto:
#               Estimate Std. Error t value Pr(>|t|)  
# (Intercept) -2.648e+01  1.710e+01  -1.548   0.1412  
# rich$pH1     9.953e+00  3.769e+00   2.641   0.0178 *
# rich$c1      4.016e-04  3.732e-02   0.011   0.9915  
# rich$NH4N1   1.491e-03  7.002e-02   0.021   0.9833  
# rich$TP1     3.233e-03  3.662e-01   0.009   0.9931 
#. . . a F test takto:
# Residual standard error: 9.304 on 16 degrees of freedom
# Multiple R-squared:  0.4537,	Adjusted R-squared:  0.3171 
# F-statistic: 3.322 on 4 and 16 DF,  p-value: 0.03674

# Zd se, e vznamn je jen pH1 - vypotejme model jen pro nj:

reg.rich2 <- lm(rich$richness~rich$pH1)

summary(reg.rich2)

# Vsledek: SE je men, F statistika ve vrazn vy a adj.R2 je vrazn vy

# Zd se, e tento model je lep - k testu pouijeme F test obou model pomoc
# funkce anova()
# H0 zde je: Modely reg.rich a reg.rich2 se neli, alfa = 95%

anova(reg.rich2,reg.rich)

# Vsledek: 
#      Res.Df    RSS Df Sum of Sq     F Pr(>F)
# 1     19 1385.0                          
# 2     16 1384.9  3  0.044304 2e-04      1
# H0 nemohu zamtnout (p=1) a tedy oba modely se neli, reg.rich tak nen statisticky
# lep, je-li tomu tak, pak mohu pout model reg.rich2, protoe nen hor ne 
# reg.rich a zrove je jednodu

# Problm pedchozho postupu je v tom, e nevm, jak kombinace je nejlep, jsem
# schopen testovat jen jestli nco nen hor, proto je lep (pokud nerozhoduji
# mezi danmi dvma modely) vyut funkce step() a Forward a Backward selection 
# metody vbru promnnch do modelu.

# Jak  to funguje?
# 1.  Musme nadefinovat nulov model, kde richness bude pouze funkc interceptu

start <- lm(rich$richness~1)

# 2. Musme nadefinovat konen model, kde jsou vechny potenciln promnn

end <- lm(rich$richness~rich$pH1+rich$c1+rich$NH4N1+rich$TP1)

# 3. Spustme pkaz step, kde definujeme nejprve nulov model, zpsob vbru a konen
# model v atributu scope

step(start, direction = "forward", scope = formula(end))

# MOdel se vybr podle hodnot AIC (m men hodnota tm lpe). Nulov model m njak 
# AIC a pidnm rznch promnnch se AIC zmn, pokud se pdnm nkter promnn AIC 
# sn oproti poten, pak je tato promnn zaazena do modelu a AIC je pepotno,
# pokud by zaazen njak dal promnn do modelu stvajc AIC medelu zmenilo, je 
# tato promnn do modelu zaazena a tak to pokrauje, a by piazen promnn znamenalo
# zven AIC - dle u promnn piazovny do modelu nejsou a je nalezen optimln model.

# N vsledek:
# Start:  AIC=102.66
# rich$richness ~ 1
# 
#               Df Sum of Sq    RSS     AIC
# + rich$pH1    1   1149.99 1385.0  91.967
# + rich$c1     1    363.44 2171.5 101.412
# <none>                    2534.9 102.662
# + rich$TP1    1     89.83 2445.1 103.904
# + rich$NH4N1  1      8.28 2526.7 104.593
#
# Step:  AIC=91.97
# rich$richness ~ rich$pH1

# Df Sum of Sq    RSS    AIC
# <none>                    1385.0 91.967
# + rich$NH4N1  1  0.032593 1384.9 93.967
# + rich$c1     1  0.002644 1385.0 93.967
# + rich$TP1    1  0.000467 1385.0 93.967

# Call:
# lm(formula = rich$richness ~ rich$pH1)
# 
# Coefficients:
# (Intercept)     rich$pH1  
#  -26.345        9.978  

# Nejlep model tedy je: lm(rich$richness ~ rich$pH1)

# 4. Pokud mme vce promnnch vybranch do modelu, tak ty se mou liit 
# podle metody vbru, je tedy teba spustt stejn pkaz, ale s opanm vbrem, logicky zanm u end a 
# nemusm zadvat nulov model, k nmu by se program dopracoval sm

step(end, direction = "backward")

# Pak se vybere mezi vsledkem backward a forward ten, kter m men vsledn AIC